function InfluLearnerReal(cascade_filename_train, N, T, beginning, ending)

warning('off','MATLAB:dispatcher:nameConflict');
addpath('~/Development/exp_fit_graph/minConf');
addpath('~/Development/exp_fit_graph/minConf/minFunc');
addpath('~/Development/exp_fit_graph/minConf/minConf');

clc;

% N = 1000;

% number of random features
K = 100;

root = 'real';
% Load cascades
% cascade_filename_train = ['cascade-1000-', num2str(filenumber), '-train'];
cascades = create_cascades([root, '/', cascade_filename_train], N, true);

% Infection label in each cascade
Y = (cascades < T);

% Source node in each cascade
S = (double(cascades == 0));

% Estimate infection probability
P = estimateC(N, T, [root, '/', cascade_filename_train], true);

W = zeros(K, N);

features = cell(N,1);

for j = beginning : ending

    if(~all(P(:,j) == 0))
        
        %fprintf('%g starts\n', j);
        tic;
        
        % Generate random features
        F = rand(N, K);
        F = double(bsxfun(@lt, F, P(:,j)));
        
        % Infection label for node j
        Y_j = Y(:,j);
        
        % Calculate random features
        phi = min(S * F,1);
       
        funObj = @(w)objFunction(w, phi, Y_j);
        w0 = 1 / K * ones(K,1);

        funProj = @(w)projectSimplex(w);
        options.verbose = 0;
        
        W(:,j) = minConf_PQN(funObj, w0, funProj,options);
              
        fprintf('%g finishes %g\n', j,toc);
        
        features{j} = F;

    end

end

dirname = [root,'/','result_', cascade_filename_train];

if(~exist(dirname,'dir'))
	
	mkdir(dirname);
	
end

save(['./', dirname, '/', 'saved-features-', num2str(beginning), '-', num2str(ending), '.mat'], 'W', 'features');

end