function [C] = create_cascades(filename, num_nodes, has_post)

if ~exist(filename,'file')
	C = [];
	return;
end

v = dlmread(filename);

if(~has_post)
    
    v = v(num_nodes+1:end,:); % take network edges

    C = inf(size(v,1),num_nodes);

    for i=1:size(v,1)
            
        C(i, v(i,1)+1) = v(i, 2);
    
        j = 3;
        while (j < size(v,2) && v(i, j+1) > 0)
            C(i, v(i,j)+1) = v(i, j+1);
            j = j+2;
        end
        
    end
    
else

    C = inf(size(v,1),num_nodes);

    for i=1:size(v,1)

        C(i, v(i,1)+1) = v(i, 3);

        j = 4;
        while (j < size(v,2) && v(i, j+2) > 0)
            C(i, v(i,j)+1) = v(i, j+2);
            j = j+3;
        end
    end

end