#include "mex.h"
#include "Common.h"
#include "LearningInfluenceFunction.h"

using namespace std;

void mexFunction(
		 int nlhs,       mxArray *plhs[],
		 int nrhs, const mxArray *prhs[]
		 )
{
	unsigned N = mxGetScalar(prhs[0]);
	
	double T = mxGetScalar(prhs[1]);
	
	string cascade_filename_train(mxArrayToString(prhs[2]));
	
	bool *has_post = mxGetLogicals(prhs[3]);

	cout << N << " " << T << " " << cascade_filename_train << " " << has_post[0] << endl;
	
 	LearningInfluenceFunction lif(N, cascade_filename_train);
 
 	lif.LoadCascade(cascade_filename_train, has_post[0]);

	lif.EstimateIndependentC(T);

	//lif.PrintC();
    
    unsigned nzmax = 0;
    
    for(map<unsigned, map<unsigned, double> >::const_iterator row = lif.m_C.begin(); row != lif.m_C.end(); ++ row)
    {
        nzmax += row->second.size();
    }
    
    //cout << nzmax << endl;
   
    mxArray *row = mxCreateDoubleMatrix(nzmax,1,mxREAL);
    mxArray *col = mxCreateDoubleMatrix(nzmax,1,mxREAL);
    mxArray *value = mxCreateDoubleMatrix(nzmax,1,mxREAL);
    
    double *pr_row = mxGetPr(row);
    double *pr_col = mxGetPr(col);
    double *pr_value = mxGetPr(value);
    
    unsigned k = 0;
    for (map<unsigned, map<unsigned, double> >::const_iterator m_row = lif.m_C.begin(); m_row != lif.m_C.end(); ++ m_row)
    {
        for (map<unsigned, double>::const_iterator m_col = m_row->second.begin(); m_col != m_row->second.end(); ++ m_col)
        {
            pr_row[k] = m_row->first + 1;
            pr_col[k] = m_col->first + 1;
            pr_value[k] = m_col->second;
            
            ++ k;
        }
    }
    
    //cout << k << endl;
    
    mxArray *tmp[5];
    tmp[0] = row;
    tmp[1] = col;
    tmp[2] = value;
    tmp[3] = mxCreateDoubleScalar(N);
    tmp[4] = mxCreateDoubleScalar(N);
    
    mexCallMATLAB(1, plhs, 5, tmp, "sparse");
	
}