#include "mex.h"
#include "Common.h"
#include "Simulation.h"

using namespace std;


void mexFunction(
		 int nlhs,       mxArray *plhs[],
		 int nrhs, const mxArray *prhs[]
		 )
{
	unsigned N = mxGetScalar(prhs[0]);
	
	double T = mxGetScalar(prhs[1]);
	
	string inferred_graph_filename(mxArrayToString(prhs[2]));
	
	unsigned number_sources = mxGetNumberOfElements(prhs[3]);
    
    	double *tmp = mxGetPr(prhs[3]);
    
    	set<unsigned> sources(tmp, tmp + number_sources);
	
	Graph inferred_G(inferred_graph_filename, N);
	inferred_G.LoadWeibullFormatNetwork(",", false);

	Simulation cascade_generator_inferred(&inferred_G);
	
	double inferred_influence = cascade_generator_inferred.RandomSimulation(T, sources, 1000);
	
	plhs[0] = mxCreateDoubleScalar(inferred_influence);

}
