function test(num_samples, network_filename, source_filename)
clc;

dirname = 'synthetic';

% 'weibull_kronecker-n1024-e1126-0-network'
T = 10.0;

% 'synthetic_sources_0'
inputdata = load([dirname,'/',source_filename,'.mat'],'test_sources');

num_soruces = size(inputdata.test_sources,1);

N = 1024;
[G, shape, scale] = readNetwork(['./',dirname,'/',network_filename,'.txt'], N);

model = load(['./',dirname,'/', source_filename, '/', 'result-train_cascade_C',num2str(num_samples),'_', network_filename,'/','saved-features-power-law-1-1024.mat'], 'W', 'features');

idx = find(G);
[I,J] = find(G);

true_influence = zeros(num_soruces,1);

estimate_influence_rf = true_influence;

iteration = 1;

simulations = 500;

for c = 1 : num_soruces
    
   sources = inputdata.test_sources{c};
   
    L = zeros(length(simulations),1);
    
    for k = 1 : simulations
    
        sampled_G = sparse(I, J, wblrnd(scale(idx), shape(idx)), N, N);
        
        cascade = zeros(length(sources), N);
        
        for i = 1 : length(sources)
            
            cascade(i,:) = graphshortestpath(sampled_G, sources(i));
            
        end
        
        [infection_time, ~] = min(cascade,[],1);
        
        infected_nodes = find(infection_time < T);
        
        L(k) = length(infected_nodes);
        
    end
    
    chi_B = zeros(1, N);
    chi_B(sources) = 1;
    
   for u = 1 : N
       
          if(~isempty(model.features{u}))
          
             phi = min(chi_B * model.features{u},1);
             
             estimate_influence_rf(iteration) = estimate_influence_rf(iteration) + phi * model.W(:,u);
              
          end
        
    end
    
      
    true_influence(iteration) = mean(L);
    
    fprintf('iteration : %g; #sources : %g; true influence : %g; estimated influence : %g\n',iteration, length(sources), true_influence(iteration), estimate_influence_rf(iteration));
    
    iteration = iteration + 1;

end

fprintf('true influence : %g\n mae_randomfeature : %g\n', mean(true_influence), mean(abs(true_influence - estimate_influence_rf)));

