function testReal(filenumber)

N = 1000;

root = 'real';

load([root,'/','result_cascade-1000-',num2str(filenumber),'-train/saved-features-1-1000.mat'], 'W', 'features');

saveddata = dlmread([root,'/', 'sources_', num2str(filenumber)]);

S = 10;

mae = 0;

K = size(saveddata,1);

for k = 1 : K;
   
    sources = saveddata(k,1 : S) + 1;
    
    chi_B = sparse(1, sources, 1, 1, N); 
    
    estimate_influence = S;
    
    for u = 1 : N
        
        if(~isempty(features{u}))
            
            phi = min(chi_B * features{u},1);
            
            estimate_influence = estimate_influence + phi * W(:,u);
            
        end
    end
    
%   uncomment the following line to  estimate true influence by simulations from scratch
% 	real_influence = estimaterealinfluence(N, 15, [root,'/','cascade-1000-',num2str(filenumber),'-test'], true, sources - 1);

%    the last column of the saveddata also stores the precomputed true
%    influence
	 real_influence = saveddata(k, end);

     fprintf('%g %g %g\n', k, real_influence, estimate_influence);
     mae = mae + abs(real_influence - estimate_influence);
    
end

fprintf('MAE %g\n', mae / K);


